//
//  parameters.hpp
//  Entrepreneurship
//
//  Created by Huang Zhiyi on 23/1/2016.
//  Copyright © 2016 Huang Zhiyi. All rights reserved.
//

#ifndef parameters_hpp
#define parameters_hpp

const unsigned short    ITER = 1;
const int               num_id = 6000;

const unsigned short    AGE = 17;                   // t, 20 to 100, 5 years per period **** no 100 stage
const unsigned short    RETIRE_AGE = 9;             // 65, retirement age
const unsigned short    VIVOS_AGE = 6;              // 50, age for vivos transfer
const unsigned short    SCHOOL_AGE = 0;


const unsigned short    EDU = 3;
const unsigned short    NO_COLLEGE = 0;
const unsigned short    COLLEGE = 1;
const unsigned short    ELITE = 2;

const unsigned short    CAREER_CHOICES = 3;
const unsigned short    WORKER = 0;
const unsigned short    NON_INCORP = 1;
const unsigned short    INCORP = 2;
const unsigned short    RETIRE = 0;
const unsigned short    EXP_BUS_TYPE = 2;
const unsigned short    EXP_BUS_TYPE_RETIRE = 3;

const unsigned short    CAP = 67;                  // k, capital, -60,000 to 600,000, discretized to multiples of 10,000
const double            CAP_STEP = 10000;
const double            CAP_MIN = -60000;
const double            CAP_MAX = CAP_MIN + (CAP-1) * CAP_STEP;

const unsigned short    ABI = 7;                    // worker and entrepreneur ability grid
const float             RANGE_ABI = 2;            // range of ability grid
const unsigned short    SHOCK = 7;                // wage and investment shock grid
const float             RANGE_SHOCK = 2;             // wage and investment shock range



const float             ABI_EM_STD = 0.35;            // employee ability std
const float             ABI_UB_STD = 0.35;            // unincorporated ability std
const float             ABI_IB_STD = 0.35;            // incorporated ability std

const float             THETA_EM = 0.6;              // intergenrational employee ability transfer
const float             THETA_UB = 0.1;             // intergenerational unincorporated ability transfer
const float             THETA_IB = 0.4;             // intergenerational incorporated ability transfer
const float             OMEGA = 0.006     ;                // parent's weight on children

const float             COLLEGE_HC_EM = 0.31;       // employee ability increase for non-elite and elite colleges
const float             ELITE_HC_EM = 0.50;
const float             COLLEGE_HC_UB = 0.28;       // unincorproated ability increase for non-elite and elite colleges
const float             ELITE_HC_UB = 0.43;
const float             COLLEGE_HC_IB = 0.28;       // incorproated ability increase for non-elite and elite colleges
const float             ELITE_HC_IB = 0.56;
const float             ELITE_BAR = -100;            // elite requirement

const float             W = 21000;             // worker wage rate
const float             ALPHA_1 = 0.3;             // return to exp (worker)
const float             ALPHA_2 = -0.03;          // return to exp square (worker)
const float             ALPHA_3 = 0.0;            // return to exp (entrepreneur)
const float             ALPHA_4 = 0.0;          // return to exp square (entrepreneur)

const float             W_STD = 0.75;                  // wage shock std
const float             N_STD = 0.58;                  // non-incorporated investment shock std
const float             I_STD = 0.75;                  // incorporated investment shock std
const float             CONSUMP_N_STD = 0.0009;           // consumption value of non-incorporated business std
const float             CONSUMP_I_STD = 0.0005;           // consumption value of incorporated business std
const float             CONSUMP_C_STD = 0.1;          // consumption value of non-elite college std
const float             CONSUMP_E_STD = 0.1;          // consumption value of elite college std

const float             PROD_N = 20;             // productivity (non-incorporative)
const float             PROD_I = 4.1;            // productivity (incorporative)
const float             NU_UB = 0.6;                  // diminishing return to capital for unincorporated
const float             NU_IB = 0.7;                  // diminishing return to capital for incorporated
const float             RHO_UB = 0;                 // contribution of employee human capital to unincorporated income
const float             RHO_IB = 0.1;               // contribution of employee human capital to incorporated income
const float             I_CAP_CONSTRAINT = 0;  // minimum investment for incorporative 200000
const float             I_COST = 50000;             // fixed cost of operating an incorporated business
const float             N_COST = 0;             // fixed cost of operating an non-incorporated business

const float             CONSUMPTION_N = 0;        // consumption value of non-incorporated
const float             CONSUMPTION_I = 0;       // consumption value of incorporated

const float             CONSUMPTION_COLLEGE = 0.00;        // consumption value of non-elite college -0.00018
const float             CONSUMPTION_ELITE = 0.000;       // consumption value of elite college

const float             TRAN_COST_N = 0.000;        // transition cost to be an non-incorporated business owner
const float             TRAN_COST_I = 0.000;        // transition cost to be an incorproated business owner

const float             ABI_EM_MEAN = 0.0;           // average ability (employee)
const float             ABI_UB_MEAN = 0.0;           // average ability (unincorporated)
const float             ABI_IB_MEAN = 0.0;           // average ability (incorporated)
const float             LAMBDA_C = 10000;               // budget constraint for college
const float             LAMBDA_E = 1.22;            // budget constraint for entrepreneur
const float             SIGMA = 1.5;                // utility function coefficient
const float             P = 0.4;                    // pension
const float             BETA = 0.815;               // discount rate
const float             R = 0.217;                  // interest rate (annual 4%)
const float             DELTA = 0.2661;             // depreciation rate (annual 6%)
// const float             COLLEGE_TUITION = 4*12761;  // college tuition
const float             ELITE_TUITION = 4*33046;    // elite college tuition
const float             ZETA[8] = { 0.95,
    0.93,
    0.89,
    0.83,
    0.73,
    0.57,
    0.38,
    0 };         // survival rate


const float             K_CON_DIST[ABI][15] = {
    {32.97, 54.59, 3.24, 2.16, 1.08, 0, 0.54, 1.08, 0, 0.54, 0.54, 1.62, 0.54, 0.54, 0.54},
    {17.55, 53.72, 9.04, 3.19, 4.79, 1.60, 1.60, 2.13, 0.53, 2.13, 0.53, 0.53, 0.53, 1.06, 1.06},
    {11.83, 62.90, 6.45, 5.38, 3.23, 3.76, 1.61, 0.54, 1.08, 0, 0, 0.54, 0.54, 1.08, 1.08},
    {15.18, 57.59, 11.52, 3.14, 4.19, 2.09, 1.57, 0, 0, 0, 0, 2.09, 1.57, 0, 1.05},
    {10.47, 59.16, 13.09, 5.24, 4.19, 3.14, 0.52, 0, 0.52, 0.52, 0.52, 0, 0.52, 1.05, 1.05},
    {7.58, 50.51, 15.66, 6.57, 7.07, 3.03, 1.01, 0.51, 2.02, 2.02, 0.51, 2.02, 0.51, 1.01, 0},
    {9.44, 55.00, 15.00, 5.00, 3.89, 1.67, 1.11, 1.67, 2.22, 1.11, 0.56, 1.67, 1.11, 0, 0.56}}; //conditional distribution of child's initial capital on age

const float             COEF_K = 0.085;        //regressions on parental capital, coefficient of child's initial capital
const float             COEF_ABI[ABI] = {10.13, 10.13+0.46, 10.13+0.67, 10.13+0.60, 10.13+0.51, 10.13+0.92, 10.13+1.00};    //regressions on parental capital, coefficients of child's ability
const float             K_FAM_STD = 1.32;     //regressions on parental capital, standard deviation of error term

const float             TAX_ORIGINAL = 0;               // tax rate
const float             W_ORIGINAL = 21000;             // worker wage rate
const float             R_ORIGINAL = 0.217;                  // interest rate (annual 4%)
const float             PROD_ALPHA = 0.2456;      // alpha in the production function
const float             PROD_A = 2186.33;           // A in the production function

#define age(t) (20+t*5)
#define capital(k) (CAP_MIN + k * CAP_STEP)
#define exp_em(t,e) (t-(e>0))
#define h_em(a_em, e) (5 * exp(abi_grid_em[a_em] + (e == COLLEGE) * COLLEGE_HC_EM + (e == ELITE) * ELITE_HC_EM))
#define h_ub(a_ub, e) (5 * exp(abi_grid_ub[a_ub] + (e == COLLEGE) * COLLEGE_HC_UB + (e == ELITE) * ELITE_HC_UB))
#define h_ib(a_ib, e) (5 * exp(abi_grid_ib[a_ib] + (e == COLLEGE) * COLLEGE_HC_IB + (e == ELITE) * ELITE_HC_IB))
#define util(c) ((pow(c,1-SIGMA) - 1)/(1-SIGMA))
#define max(a, b) ((a > b) ? a : b)
#define financial_aid_nonelite(k_fam, a_em) max(0, (7266 - 26.56 * (capital(k_fam) / 1000 - 154.756) - ((a_em < 2)?1:0) * 6082 + ((a_em > 4)?1:0) * 5626) * 1.222 * 4)
#define financial_aid_elite(k_fam, a_em) max(0, (12440 - 26.56 * (capital(k_fam) / 1000 - 154.756) - ((a_em < 2)?1:0) * 6082 + ((a_em > 4)?1:0) * 5626) * 1.222 * 4)
#define group_mapping(group_id) ((group_id <= 10) ? (group_id + 6) : ((group_id == 11) ? 19 : ((group_id == 12) ? 24 : ((group_id == 13) ? 29 : 35)))) //mapping from capital group to capital index
#define college_tuition(subsidy) 4*12761*(1-subsidy)


#endif /* parameters_hpp */
